--[[##############################################################\
###########################[TO DO]################################|
##################################################################/
		- ScanLootTip for quest items that are consumables
		- Fix bag looting inside backpack
		-		
*******************************************************************]]
HotLoot = LibStub("AceAddon-3.0"):NewAddon("HotLoot", "AceConsole-3.0", "AceEvent-3.0")

function HotLoot:createMainFrame()
	HotLoot.mainFrame = CreateFrame("Frame", "mainFrame", UIParent);
	HotLoot.mainFrame:SetWidth(32);
	HotLoot.mainFrame:SetHeight(16);
	--mainFrame:SetFrameStrata("DIALOG");
	HotLoot.mainFrame:SetPoint("CENTER", 0, 0);
	HotLoot.mainFrame:SetScript("OnUpdate", FadeItems);
	
	HotLoot.mainFrame.mainBG = HotLoot.mainFrame:CreateTexture("mainBG", "BACKGROUND");
	HotLoot.mainFrame.mainBG:SetAllPoints(HotLoot.mainFrame);
	HotLoot.mainFrame.mainBG:SetTexture(0.1, 0.1, 0.1, 0.7);
	
	HotLoot.mainFrame.anchorText = HotLoot.mainFrame:CreateFontString(nil, "OVERLAY");
	HotLoot.mainFrame.anchorText:SetPoint("CENTER", HotLoot.mainFrame, "CENTER", 0, 0);
	HotLoot.mainFrame.anchorText:SetFont(STANDARD_TEXT_FONT, 9, "NORMAL");
	--name:SetJustifyH("LEFT");
	HotLoot.mainFrame.anchorText:SetText("ANCHOR");
	
	HotLoot.mainFrame:RegisterForDrag("LeftButton");
	HotLoot.mainFrame:SetMovable(true);
	HotLoot.mainFrame:EnableMouse(true);
	HotLoot.mainFrame:SetScript("OnDragStart", HotLoot.mainFrame.StartMoving);
	HotLoot.mainFrame:SetScript("OnDragStop", HotLoot.mainFrame.StopMovingOrSizing);
	HotLoot.mainFrame:Show();
end	

--******************ANNOUNCE FUNCTION********************

function Announce(input)
	if HotLoot:GetLootAnnounce() then
		print("|cFFCD6600HotLoot|r: " .. tostring(input));
	end
end

-- options select table
local themeTable = {
	["classic"] = "Classic",
	["frost"] = "Frost",
	["void"] = "Void",
	["cosmic"] = "Cosmic",
	["cute"] = "Cute",
	["elvui"] = "ElvUI"
}

local themes = {
	["classic"] = {
		["name"] = "Classic",
		["src"] = nil,
		["showNames"] = true,
		["disNames"] = false,
		["showQuant"] = true,
		["inlineQuant"] = false,
		["iconSize"] = 24,
		["disIconSize"] = false,
		["alpha"] = 1
	},
	["frost"] = {
		["name"] = "Frost",
		["src"] = "FrostBG",
		["xOffset"] = -24,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = true,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	},
	["void"] = {
		["name"] = "Void",
		["src"] = "VoidBG",
		["xOffset"] = -24,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = true,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	},
	["cosmic"] = {
		["name"] = "Cosmic",
		["src"] = "CosmicBG",
		["xOffset"] = -24,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = false,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	},
	["cute"] = {
		["name"] = "Cute",
		["src"] = "CuteBG",
		["xOffset"] = -24,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = false,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	},
	["elvui"] = {
		["name"] = "ElvUI",
		["src"] = "ElvBG",
		["xOffset"] = -16,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = true,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	}
}

local nameC,srcC,xOffsetC,showNamesC,disNamesC,showQuantC,inlineQuantC,iconSizeC,disIconSizeC,alphaC;

function LoadTheme(theme)
	-- load vars
	nameC = themes[theme]["name"];
	Announce("Loading theme: "..nameC);
	srcC = themes[theme]["src"];
	xOffsetC = themes[theme]["xOffset"];
	showNamesC = themes[theme]["showNames"];
	disNamesC = themes[theme]["disNames"];
	showQuantC = themes[theme]["showQuant"];
	inlineQuantC = themes[theme]["inlineQuant"];
	iconSizeC = themes[theme]["iconSize"];
	disIconSizeC = themes[theme]["disIconSize"];
	alphaC = themes[theme]["alpha"];
	
	HotLoot:SetLootShowNames(nil, showNamesC);
	HotLoot:SetLootShowQuantities(nil, showQuantC);
	HotLoot:SetInlineQuant(nil, inlineQuantC)
	HotLoot:SetLootIconSize(nil, iconSizeC);
	HotLoot:SetLootTrans(nil, alphaC);
	HotLoot:SetInlineQuant(nil, inlineQuantC);
end

function LoadThemeInit(theme)
	local nameC,srcC,xOffsetC,showNamesC,disNamesC,showQuantC,inlineQuantC,iconSizeC,disIconSizeC,alphaC;

	-- load vars
	nameC = themes[theme]["name"];
	Announce("Loading theme: "..nameC);
	srcC = themes[theme]["src"];
	xOffsetC = themes[theme]["xOffset"];
	showNamesC = themes[theme]["showNames"];
	disNamesC = themes[theme]["disNames"];
	showQuantC = themes[theme]["showQuant"];
	inlineQuantC = themes[theme]["inlineQuant"];
	iconSizeC = themes[theme]["iconSize"];
	disIconSizeC = themes[theme]["disIconSize"];
	alphaC = themes[theme]["alpha"];
	
	--HotLoot:SetLootShowNames(nil, showNamesC);
	--HotLoot:SetLootShowQuantities(nil, showQuantC);
	--HotLoot:SetInlineQuant(nil, inlineQuantC)
	--HotLoot:SetLootIconSize(nil, iconSizeC);
	--HotLoot:SetLootTrans(nil, alphaC);
	--HotLoot:SetInlineQuant(nil, inlineQuantC);
end
--[[
function SetTheme()
	if srcC then
		iconBG:SetPoint("LEFT",frame,"LEFT",xOffsetC,0);
		local path = "Interface\\AddOns\\HotLoot\\Themes\\"..srcC..".tga";
		dBug("path",path);
		iconBG:SetTexture(path);
	end
end
]]
-- disNamesC
function HotLoot:ToggleNamesDisable()
	return disNamesC;
end
-- disIconSizeC
function HotLoot:ToggleSizeDisable()
	return disIconSizeC;
end

local unitTable = {
	["rare"] = "Rare",
	["boss"] = "Boss",
	["chest"] = "Chest",
	["unitKeyword"] = "Unit Keyword"
}

local closeKeyTable = {
	["0"] = "None",
	["ctrl"] = "Control",
	["shift"] = "Shift",
	["alt"] = "Alt"
}

local growthDirectionTable = {
	[1] = "Up",
	[-1] = "Down"
}

-- SetTextSide
local textSideTable = {
	[0] = "Right",
	[1] = "Left"
}
		--[[
		cff9d9d9dPoor
		cffffffffCommon
		SetLootUncommon
		cff0070ddRare
		SetLootEpic
		]]
local itemTypeTable = {
	["0None"] = "None",
	["Quest"] = "Quest Items",
	["Junk"] = "Junk",
	["Gem"] = "Gems",
	["Metal & Stone"] = "Metal & Stone",
	["Cooking Ingredient"] = "Cooking Ingredients",
	["Herb"] = "Herbs",
	["Leather"] = "Leather",
	["Cloth"] = "Cloth",
	["Elemental"] = "Elementals",
	["Potion"] = "Potions",
	["Flask"] = "Flasks",
	["Elixir"] = "Elixirs",
	["z1Poor"] = "|cff9d9d9dPoor|r",
	["z2Common"] = "|cffffffffCommon|r",
	["z3Uncommon"] = "|cff1eff00Uncommon|r",
	["z4Rare"] = "|cff0070ddRare|r",
	["z5Epic"] = "|cffa335eeEpic|r",
	["z6Legendary"] = "|cffff8000Legendary|r",
	["Include"] = "Include List",
}

-- options
local options = {
    name = "HotLoot",
    handler = HotLoot,
    type = "group",
	childGroups = "tree",
    args = {
		lootDesc = {
			name = "HotLoot is an autoloot filter designed to streamline the looting process. This AddOn allow you to automatically loot various items related to professions and quests.\n",			
			type = "description",
			order = 0
		},
		lootDesc3 = {
			name = "NOTE: In order for HotLoot to work effectively please ensure that all other autoloot AddOns and options are turned off.\n",  
			type = "description",
			order = 2
		},
		groupSystem = {
			name = "System",
			type = "group",
			order = 4,
			args = {
				lootEnabled = {
					name = "Enable",
					desc = "check to enable HotLoot",
					type = "toggle",
					set = "SetLootEnabled",
					get = "GetLootEnabled",
					order = 1
				},
				lootDebug = {
					name = "Debug Mode",
					desc = "Check to enable debugging.",
					type = "toggle",
					set = "SetLootDebug",
					get = "GetLootDebug",
					order = 2
				},
				lootAnnounce = {
					name = "Announce Events",
					desc = "Check to have |cFFCD6600HotLoot|r announce various events such as item deletions etc.",
					type = "toggle",
					set = "SetLootAnnounce",
					get = "GetLootAnnounce",
					order = 3
				},
				groupLWindow = {
					name = "Loot Window",
					type = "group",
					order = 50,
					inline = true,
					args = {
						lootClose = {
							name = "Autoclose Loot Window",
							desc = "Check to automatically close the loot window after autolooting\n\nHold |cFFFFCC00Ctrl|r (or whichever key you choose) to temporarily disable while looting.",
							type = "toggle",
							set = "SetLootClose",
							get = "GetLootClose",
							order = 1
						},
						lootCloseKey = {
							name = "Autoclose Loot Window Modifier Key",
							desc = "Here you can choose the modifier key to temporarily disable autoclosing the loot window if it is enabled.",
							type = "select",
							values = closeKeyTable,
							set = "SetLootCloseKey",
							get = "GetLootCloseKey",
							order = 2
						},
					},
				},
				--[[
				groupUnit = {
					name = "Unit Specific",
					type = "group",
					order = 75,
					inline = true,
					args = {							
					},
				},
				]]
				groupSkinning = {
					name = "Skinning Mode",
					type = "group",
					order = 100,
					inline = true,
					args = {
						lootSkinKey = {
							name = "Skinning Mode Modifier Key",
							desc = "Here you can choose the modifier key to temporarily enable Skinning Mode.",
							type = "select",
							values = closeKeyTable,
							set = "SetLootSkinKey",
							get = "GetLootSkinKey",
							order = 2
						},
						skinmode = {
							name = "Skinning Mode",
							desc = "Skinning mode will pick up and delete any items left over after autolooting.\n|cFFFF0000(WARNING: use with caution this deletes items. HL is not responsible for lost items.)",
							type = "toggle",
							set = "SetLootSkinMode",
							get = "GetLootSkinMode",
							confirm = true,
							order = 1
						},
					},
				},
			}, 
		},
		goupLootMonitor = {
			name = "Loot Monitor", 
			type = "group", 
			order = 5, 
			args = {
				lootEnableMonitor = {
					name = "Enable Loot Monitor",
					--desc = " ",
					type = "toggle",
					set = "SetLootEnableMonitor",
					get = "GetLootEnableMonitor",
					order = 1
				},
				lootShowAnchor = {
					name = "Show Anchor",
					desc = "Shows the anchor so you can move the Loot Monitor.",
					desc = "Shows the anchor so you can move the Loot Monitor.",
					type = "toggle",
					set = "SetLootShowAnchor",
					get = "GetLootShowAnchor",
					order = 2
				},
				lootShowNames = {
					name = "Show Item Names",
					desc = "Shows the item names next to the icons in the Loot Monitor.\n\n|cFFFF0000(must be off to use grid mode)|r",
					type = "toggle",
					set = "SetLootShowNames",
					get = "GetLootShowNames",
					disabled = "ToggleNamesDisable",
					order = 3
				},
				lootShowQuantities = {
					name = "Show Item Quantities",
					desc = "Shows the quantities of the items on top of icons in the Loot Monitor.",
					type = "toggle",
					set = "SetLootShowQuantities",
					get = "GetLootShowQuantities",
					order = 4
				},
				lootIconSize = {
					name = "Icon Size",
					desc = "Set the size of the Loot Monitor item icons in increments of 8.",
					type = "range",
					min = 8,
					max = 32,
					step = 8, 
					bigStep = 8,
					disabled = "ToggleSizeDisable",
					set = "SetLootIconSize",
					get = "GetLootIconSize",
					order = 5
				},
				lootTransparency = {
					name = "Transparency",
					desc = "Set the transparency of the Loot Monitor.",
					type = "range",
					min = 0,
					max = 1,
					step = 0.1, 
					bigStep = 0.1,
					--disabled = "ToggleSizeDisable",
					set = "SetLootTrans",
					get = "GetLootTrans",
					order = 6
				},
				lootGrowthDirection = {
					name = "Growth Direction",
					desc = "Here you can choose whether the monitor grows up or down.",
					type = "select",
					values = growthDirectionTable,
					set = "SetLootGrowthDirection",
					get = "GetLootGrowthDirection",
					order = 7
				},
				textSide = {
					name = "Text Side",
					desc = "Here you can choose whether the loot item names show on the right or left.",
					type = "select",
					values = textSideTable,
					set = "SetTextSide",
					get = "GetTextSide",
					order = 8
				},
				inlineQuant = {
					name = "Inline Quantities",
					desc = "Shows the quantities alongside the item names.",
					type = "toggle",
					set = "SetInlineQuant",
					get = "GetInlineQuant",
					order = 9
				},
				themeSelect = {
					name = "Theme",
					desc = "Here you can choose whether the look of the monitor.",
					type = "select",
					values = themeTable,
					set = "SetThemeSelect",
					get = "GetThemeSelect",
					--disabled = true,
					order = 10
				},
				themeColor = {
					name = "Border Color",
					--desc = "Here you can choose whether the look of the monitor.",
					type = "color",
					--values = themeTable,
					set = "SetThemeColor",
					get = "GetThemeColor",
					--hidden = "ToggleThemeColorHide",
					hidden = true,
					order = 11
				},
				groupGridMode = {
					name = "Grid Mode",
					type = "group",
					order = 12,
					inline = true,
					disabled = "ToggleGridDisable",
					args = {
						lootGridMode = {
							name = "Icon Grid Mode",
							desc = "Icons display in a grid style.\n\n|cFFFF0000(show names must be off)|r",
							type = "toggle",
							set = "SetLootGridMode",
							get = "GetLootGridMode",
							order = 1
						},
						lootGridNumColumns = {
							name = "Grid Columns",
							type = "range",
							min = 1,
							max = 10,
							step = 1, 
							bigStep = 1,
							set = "SetLootGridNumColumns",
							get = "GetLootGridNumColumns",
							order = 2
						},
					},
				},
				groupMonButs = {
					name = " ",
					type = "group",
					order = 13,
					inline = true,
					args = {
						lootTestMonitor = {
							name = "Test Monitor",
							--desc = " ",
							type = "execute",
							func = "TestMonitor", 
							order = 1
						},
						lootResetMonitor = {
							name = "Reset Anchor",
							--desc = " ",
							type = "execute",
							func = "ResetMonitor", 
							order = 2
						},
					},
				},
				lootDesc = {
					name = "\nNOTE: This monitor is designed to only show loot that is specifically looted automatically. It will not show items that you loot manually.",
					type = "description",
					order = 14,
				},
			}, 
		},
		groupGeneral = {
			name = "General",
			type = "group",
			order = 6,
			args = {
				lootGold = {
					name = "Loot Gold",
					desc = "Check to autoloot gold.",
					type = "toggle",
					set = "SetLootGold",
					get = "GetLootGold",
					order = 1
				},
				lootCurrency = {
					name = "Loot Currency",
					desc = "Check to autoloot Currency.\n(i.e. Lesser Charm of Good Fortune)",
					type = "toggle",
					set = "SetLootCurrency",
					get = "GetLootCurrency",
					order = 2
				},
				lootQuest = {
					name = "Loot Quest Items",
					desc = "Check to autoloot quest items.",
					type = "toggle",
					set = "SetLootQuest",
					get = "GetLootQuest",
					order = 3
				},
				lootJunk = {
					name = "Loot Junk", 
					desc = "Check to autoloot junk (grey items).",
					type = "toggle",
					set = "SetLootJunk",
					get = "GetLootJunk",
					order = 4
				},
			},
		},
		groupProfessions = {
			name = "Professions",
			type = "group",
			order = 7,
			args = {
				lootCloth = {
					name = "Loot Cloth",
					desc = "Check to autoloot cloth.",
					type = "toggle",
					set = "SetLootCloth",
					get = "GetLootCloth",
					order = 0
				},
				lootMining = {
					name = "Loot Mining",
					desc = "Check to autoloot mining items.",
					type = "toggle",
					set = "SetLootMining",
					get = "GetLootMining",
					order = 1
				},
				lootGems = {
					name = "Loot Gems",
					desc = "Check to autoloot gems.",
					type = "toggle",
					set = "SetLootGems",
					get = "GetLootGems",
					order = 2
				},
				lootHerbs = {
					name = "Loot Herbs",
					desc = "Check to autoloot herbs.",
					type = "toggle",
					set = "SetLootHerbs",
					get = "GetLootHerbs",
					order = 3
				},
				lootSkinning = {
					name = "Loot Leather",
					desc = "Check to autoloot leather.",
					type = "toggle",
					set = "SetLootSkinning",
					get = "GetLootSkinning",
					order = 4
				},
				lootFishing = {
					name = "Loot Fishing",
					desc = "Check to autoloot fishing.",
					type = "toggle",
					set = "SetLootFishing",
					get = "GetLootFishing",
					order = 5
				},
				lootCooking = {
					name = "Loot Cooking Ingredients",
					desc = "Check to autoloot cooking ingredients.\n\n|cff1eff00Note: Blizzard has cooking ingredients spread all over different categories but this should get most of them.|r",
					type = "toggle",
					set = "SetLootCooking",
					get = "GetLootCooking",
					order = 6
				},
			}
		},
		groupDrops = {
			name = "Common Drops",
			type = "group",
			order = 8,
			args = {
				lootPots = {
					name = "Loot Potions",
					desc = "Check to autoloot potions.",
					type = "toggle",
					set = "SetLootPots",
					get = "GetLootPots",
					order = 2
				},
				lootFlasks = {
					name = "Loot Flasks",
					desc = "Check to autoloot flasks.",
					type = "toggle",
					set = "SetLootFlasks",
					get = "GetLootFlasks",
					order = 3
				},
				lootElixirs = {
					name = "Loot Elixirs",
					desc = "Check to autoloot elixirs.",
					type = "toggle",
					set = "SetLootElixirs",
					get = "GetLootElixirs",
					order = 4
				},
				lootMoH = {
					name = "Loot Motes of Harmony",
					desc = "Check to autoloot Motes of Harmony.",
					type = "toggle",
					set = "SetLootMoH",
					get = "GetLootMoH",
					order = 5
				},
				lootElemental = {
					name = "Loot Elementals",
					desc = "Check to autoloot Elemental items.\n(i.e. Mote of Water)",
					type = "toggle",
					set = "SetLootElemental",
					get = "GetLootElemental",
					order = 6
				},	
			},
		},
		groupTimeless = {
			name = "Timeless Isle",
			type = "group",
			order = 9,
			args = {
				timelessDesc1 = {
					name = "These are some items that commonly drop in the Timeless Isle and are generally wanted.\n(this is an ongoing list so it will be added to as needed)\n(if you have anything you would like to see on this list or anywhere else please comment on HotLoot's Curse page!)",			
					type = "description",
					order = 0,
				},
				groupTBuffs = {
					name = "Buff Items",
					type = "group",
					order = 1,
					inline = true,
					args = {
						lootBotA = {
							name = "Loot Book of the Ages",
							desc = "Check to autoloot Books of the Ages.",
							type = "toggle",
							set = "SetLootBotA",
							get = "GetLootBotA",
							order = 2,
						},
						lootDoEM = {
							name = "Loot Dews of Eternal Morning",
							desc = "Check to autoloot Dew of Eternal Morning.",
							type = "toggle",
							set = "SetLootDoEM",
							get = "GetLootDoEM",
							order = 3,
						},
						lootSC = {
							name = "Loot Singing Crystals",
							desc = "Check to autoloot Singing Crystals.",
							type = "toggle",
							set = "SetLootSC",
							get = "GetLootSC",
							order = 4,
						},
						lootRepMeat = {
							name = "Loot Quest Meat",
							desc = "Check to autoloot meat that can be turned in for coins.",
							type = "toggle",
							set = "SetLootRepMeat",
							get = "GetLootRepMeat",
							order = 5,
						},
					},
				},
			},
		},
		groupQuality = {
			name = "Item Quality",
			type = "group",
			order = 9,
			args = {
				magicDesc1 = {
					name = "For now items will only be able to be looted when not in a group.\nThese options will loot ALL items of that quality.",			
					type = "description",
					order = 1,
				},
				lootPoor = {
					name = "Loot |cff9d9d9dPoor|r Items",
					desc = "\nCheck to autoloot |cff9d9d9dPoor|r items.",
					type = "toggle",
					set = "SetLootPoor",
					get = "GetLootPoor",
					order = 2,
				},
				spacerQ1 = {
					name = "",			
					type = "description",
					order = 3,
				},
				lootCommon = {
					name = "Loot |cffffffffCommon|r Items",
					desc = "\nCheck to autoloot |cffffffffCommon|r items.",
					type = "toggle",
					set = "SetLootCommon",
					get = "GetLootCommon",
					order = 4,
				},
				spacerQ2 = {
					name = "",			
					type = "description",
					order = 5,
				},
				lootUncommon = {
					name = "Loot |cff1eff00Uncommon|r Items",
					desc = "\nCheck to autoloot |cff1eff00Uncommon|r items.",
					type = "toggle",
					set = "SetLootUncommon",
					get = "GetLootUncommon",
					order = 6,
				},	
				spacerQ3 = {
					name = "",			
					type = "description",
					order = 7,
				},
				lootRare = {
					name = "Loot |cff0070ddRare|r Items",
					desc = "Check to autoloot |cff0070ddRare|r items.",
					type = "toggle",
					set = "SetLootRare",
					get = "GetLootRare",
					order = 8,
				},
				spacerQ4 = {
					name = "",			
					type = "description",
					order = 9,
				},
				lootEpic = {
					name = "Loot |cffa335eeEpic|r Items",
					desc = "Check to autoloot |cffa335eeEpic|r items.",
					type = "toggle",
					set = "SetLootEpic",
					get = "GetLootEpic",
					order = 10,
				},
				spacerQ5 = {
					name = "",			
					type = "description",
					order = 11,
				},
				lootLegendary = {
					name = "Loot |cffff8000Legendary|r Items",
					desc = "Check to autoloot |cffff8000Legendary|r items.",
					type = "toggle",
					set = "SetLootLegendary",
					get = "GetLootLegendary",
					order = 12,
				},
			},
		},
		groupInclude = {
			name = "Include List",
			type = "group",
			order = 11,
			args = {
				includeList = {
					name = "Here you can write items you want to include when autolooting.\n(ie. Linen Cloth, Iron Ore)",
					multiline = 7,
					type = "input",
					set = "SetIncludeList",
					get = "GetIncludeList",
					width = "full",
					order = 1
				},
			},
		},
		groupExclude = {
			name = "Exclude List",
			type = "group",
			order = 12,
			args = {
				excludeList = {
					name = "Here you can write items you want excluded from autolooting.\n(ie. Linen Cloth, Iron Ore)",
					multiline = 7,
					type = "input",
					set = "SetExcludeList",
					get = "GetExcludeList",
					width = "full",
					order = 1
				},
			}
		},
		groupThresholds = {
			name = "Value Thresholds",
			type = "group",
			order = 13,
			args = {
				groupT1 = {
					name = "Threshold 1",
					type = "group",
					order = 1,
					inline = true,
					args = {
						type1 = {
							name = "Item Type",
							desc = "Choose the item type to apply this threshold to.",
							type = "select",
							values = itemTypeTable,
							set = "SetType1",
							get = "GetType1",
							order = 2
						},
						value1 = {
							name = "Threshold",
							type = "input",
							set = "SetValue1",
							get = "GetValue1",
							--pattern = "(%d?%d)[gsc]",
							pattern = "(%d?%d)g%s*(%d?%d)s%s*(%d?%d)c",
							usage = "Value must be entered as ##g ##s ##c.",
							--usage = "Value is entered in gold.",
							--width = "full",
							order = 3
						},
					},
				},
				groupT2 = {
					name = "Threshold 2",
					type = "group",
					order = 2,
					inline = true,
					args = {
						type2 = {
							name = "Item Type",
							desc = "Choose the item type to apply this threshold to.",
							type = "select",
							values = itemTypeTable,
							set = "SetType2",
							get = "GetType2",
							order = 5
						},
						value2 = {
							name = "Threshold",
							type = "input",
							set = "SetValue2",
							get = "GetValue2",
							--pattern = "(%d+)",
							pattern = "(%d?%d)g%s*(%d?%d)s%s*(%d?%d)c",
							usage = "Value must be entered as ##g ##s ##c.",
							--usage = "Value is entered in gold.",
							--width = "full",
							order = 6
						},
					},
				},
				groupT3 = {
					name = "Threshold 3",
					type = "group",
					order = 3,
					inline = true,
					args = {
						type3 = {
							name = "Item Type",
							desc = "Choose the item type to apply this threshold to.",
							type = "select",
							values = itemTypeTable,
							set = "SetType3",
							get = "GetType3",
							order = 8
						},
						value3 = {
							name = "Threshold",
							type = "input",
							set = "SetValue3",
							get = "GetValue3",
							--pattern = "(%d+)",
							pattern = "(%d?%d)g%s*(%d?%d)s%s*(%d?%d)c",
							usage = "Value must be entered as ##g ##s ##c.",
							--usage = "Value is entered in gold.",
							--width = "full",
							order = 9
						},
					},
				},
			},
		},
		groupUnit = {
			name = "Unit Filter",
			type = "group",
			order = 14,
			disabled = true,
			args = {
				unitEnable = {
					name = "Enable",
					desc = "Skinning mode will pick up and delete any items left over after autolooting.\n|cFFFF0000(WARNING: use with caution this deletes items. HL is not responsible for lost items.)",
					type = "toggle",
					set = "SetUnitEnable",
					get = "GetUnitEnable",
					order = 0
				},
				typeSelect = {
					name = "Unit Select",
					desc = "Here you can choose the modifier key to temporarily disable auto closing the loot window if it is enabled.",
					type = "multiselect",
					values = unitTable,
					set = "SetTypeSelect",
					get = "GetTypeSelect",
					order = 1
				},
				unitKeyword = {
					name = "Unit Keyword",
					desc = "Here you can choose the modifier key to temporarily enable Skinning Mode.",
					type = "input",
					set = "SetUnitKeyword",
					get = "GetUnitKeyword",
					hidden = "ToggleKeywordHide",
					order = 2
				},
				spacer2 = {
					name = "",			
					type = "description",
					order = 3,
				},
				unitLoot = {
					name = "Autoloot",
					desc = "Skinning mode will pick up and delete any items left over after autolooting.\n|cFFFF0000(WARNING: use with caution this deletes items. HL is not responsible for lost items.)",
					type = "toggle",
					set = "SetUnitLoot",
					get = "GetUnitLoot",
					order = 4
				},
				unitClose = {
					name = "Autoclose",
					desc = "Skinning mode will pick up and delete any items left over after autolooting.\n|cFFFF0000(WARNING: use with caution this deletes items. HL is not responsible for lost items.)",
					type = "toggle",
					set = "SetUnitClose",
					get = "GetUnitClose",
					order = 5
				},
			},
		},
    },
}



-- Config Defaults
local defaults = {
	char = {
		minimap = {
			hide = false,
		},
		lootEnabled = true,
		lootDebug = false,
		lootAnnounce = true,
		lootClose = false,
		lootCloseKey = "0",
		lootSkinMode = false,
		lootSkinKey = "0", 
		lootEnableMonitor = true,
		lootShowAnchor = true,
		lootShowNames = true, 
		lootShowQuantities = true, 
		lootIconSize = 32, 
		lootGrowthDirection = -1, 
		textSide = 0,
		themeSelect = "classic",
		themeSelect = 1,
		themeColorR = 0,
		themeColorG = 1,
		themeColorB = 1,
		lootGridMode = false,
		lootGridNumColumns = 4,
		lootGold = true,
		lootQuest = false,
		lootJunk = false,
		lootJunkDel = false,
		lootCloth = false,
		lootMining = false,
		lootGems = false,
		lootHerbs = false,
		lootSkinning = false,
		lootFishing = false,
		lootCooking = false,
		lootPots = false,
		lootFlasks = false,
		lootElixirs = false,
		lootMoH = false,
		lootElemental = false,
		lootSetLootCurrency = false,
		lootBotA = true,
		lootDoEM = true,
		lootSC = true,
		lootPoor = false,
		lootCommon = false,
		lootUncommon = false,
		lootRare = false,
		lootEpic = false,
		lootCustom = false,
		excludeList = " ",
		includeList = " ",
	}
}


-- OnInitialize
function HotLoot:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("HotLootDB", defaults, true)
    LibStub("AceConfig-3.0"):RegisterOptionsTable("HotLoot", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HotLoot", "HotLoot")
    self:RegisterChatCommand("hl", "ChatCommand")
    self:RegisterChatCommand("hotloot", "ChatCommand")
	HotLoot:createMainFrame();
end


-- OnEnable
function HotLoot:OnEnable()
	
	tStart = 0;
	HotLoot:ToggleAnchor(HotLoot:GetLootShowAnchor());
	LoadThemeInit(HotLoot:GetThemeSelect());
end

-- ChatCommand
function HotLoot:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame);
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame);
    else
        LibStub("AceConfigCmd-3.0"):HandleCommand("hl", "HotLoot", input);
    end
end

-- debug mode
local function dBug(name, value)
	if (HotLoot:GetLootDebug() == true) then
		print(tostring(name) .. " = " .. tostring(value));
	end
end
--[[
local function CloseEL()
	if IsAddOnLoaded("ElvUI") and _G["ElvLootFrame"]:IsVisible() then
		local elvHFrame = _G["ElvLootFrame"];
		_G["ElvLootFrame"]:HookScript("OnShow", function(self) 
			self:Hide()
		end)	
	end
end]]
-- *****************CheckTreshold************
function CheckThreshold(iType, sellAmount)
	if HotLoot:GetType1() == iType then
		if tonumber(ToCopper(HotLoot:GetValue1())) <= sellAmount then
			return true
		else
			return false
		end
	elseif HotLoot:GetType2() == iType then
		if tonumber(ToCopper(HotLoot:GetValue2())) <= sellAmount then
			return true
		else
			return false
		end
	elseif HotLoot:GetType3() == iType then
		if tonumber(ToCopper(HotLoot:GetValue3())) <= sellAmount then
			return true
		else
			return false
		end
	else
		return true
	end
end
--**************thresh validator*******************
--[[
string.match("24g 08s 10c","(%d+)g" <== gold
string.match("24g 08s 10c","(%d+)s" <== silver
string.match("24g 08s 10c","(%d+)c" <== copper
]]
local function ValThresh(info, value)
	
end
function round(num, idp)
    local mult = 10^(idp or 0)
    if num >= 0 then return math.floor(num * mult + 0.5) / mult
    else return math.ceil(num * mult - 0.5) / mult end
end
-- *******TOOLTIP SCANNER*************
local hgScanningTooltip = CreateFrame( "GameTooltip", "hgScanningTooltip", UIParent, "GameTooltipTemplate" ); -- Tooltip name cannot be nil
hgScanningTooltip:SetOwner( UIParent, "ANCHOR_NONE" );
--[[
hgScanningTooltip:AddFontStrings(
	hgScanningTooltip:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" ),
	hgScanningTooltip:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" ));
]]
	
	
--[[	
local function EnumerateTooltipLines_helper(lftext)
	local text = _G["ScanningTooltipTextLeft2"]:GetText();
	if tostring(text) == tostring(lftext) then
		ScanningTooltip:ClearLines();
		return true;
	end
end

local function EnumerateTooltipLines_helper(lftext, ...)
    for i = 1, select("#", ...) do
        local region = select(i, ...)
        if region and region:GetObjectType() == "FontString" then
            local text, ... = region:GetText() -- string or nil
			if tostring(text) == tostring(lftext) then
				ScanningTooltip:ClearLines();
				return true;
			end
        end
    end
end

function EnumerateTooltipLines(lftext, tooltip) -- good for script handlers that pass the tooltip as the first argument.
    if EnumerateTooltipLines_helper(lftext) then
		return true;
	end
end
]]
function ScanLootTip(lftext,slot)
	if GetLootSlotType(slot) == 1 --[[and select(4, GetLootSlotInfo(slot)) <= 1]] then
		--ScanningTooltip:ClearLines();
		hgScanningTooltip:SetLootItem(slot);
		local text = _G["hgScanningTooltipTextLeft2"]:GetText();
		if text == tostring(lftext) then
			--hgScanningTooltip:ClearLines();
			return true;
		else
			--hgScanningTooltip:ClearLines();
			return false;
		end
	else
		return false;
	end
end

--*****************CHECK FOR ROOM****************
function HasRoom(room)
	local numFSlots = 0;
	for b = 0, 4 do 
		numFSlots = numFSlots + select(1, GetContainerNumFreeSlots(b));
	end
	dBug("Number of free slots", numFSlots);
	if  numFSlots >= room then
		return true;
	else
		return false;
	end
end
--********************CHECK STACKABLE********************
-- and (HasRoom() or CanStack())
function CanStack(iname, scount, lquant)
	local q, stackRoom, n;
	stackRoom = 0;
	for b = 0, 4 do 
		for s = 1, GetContainerNumSlots(b) do 
			n = select(1, GetItemInfo(GetContainerItemID(b, s)));
			if n == iname then
				q = select(2, GetContainerItemInfo(b, s));
				stackRoom = (stackRoom) + (scount - q);
			end
		end
	end
	dBug("stackRoom",stackRoom)
	if lquant <= stackRoom then
		return true;	
	else
		return false;
	end
end

-- **********GET ITEM ID***************
function GetItemID(itemLink)
	local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLink,
		"|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
	return tonumber(Id);
end
--local monitor = HotLoot.createMainFrame();
local icons = {};				
local lItems = {};
local closeEL = 0;
-- HotLoot autoloot modudle
local trigger = 0;
local eFrame, events = CreateFrame("Frame"), {};
function events:LOOT_OPENED(...)
	--if GetMouseFocus() then
		local mFocus = GetMouseFocus():GetName();
	--end
	local arg1 = ...;
	if (HotLoot:GetLootEnabled() == true) and (arg1 == 0) then
		local numSlots, curSlot, bFull;
		bFull = 0;
		numSlots = GetNumLootItems();
		curSlot = 1;
		lItems = " ";
		local sKeyDown, keyDown, modKey;
		modKey = HotLoot:GetLootCloseKey();
		if (modKey == "ctrl") then 
			keyDown = IsControlKeyDown();
		elseif (modKey == "shift") then 
			keyDown = IsShiftKeyDown();
		elseif (modKey == "alt") then 
			keyDown = IsAltKeyDown();
		end
		modKey = HotLoot:GetLootSkinKey();
		if (modKey == "ctrl") then 
			sKeyDown = IsControlKeyDown();
		elseif (modKey == "shift") then 
			sKeyDown = IsShiftKeyDown();
		elseif (modKey == "alt") then 
			sKeyDown = IsAltKeyDown();
		end
		
		
		--[[--------------------------------
		------LOOTING LOOP------------------
		----------------------------------]]
		while (curSlot <= numSlots) do
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice;
			local lootLink, isLooted, isGold, itemID;
			isGold = false;
			isLooted = false;
			local lootIcon, lootName, lootQuantity, rarity, locked;
			lootIcon, lootName, lootQuantity, rarity, locked = GetLootSlotInfo(curSlot);
			lootLink = GetLootSlotLink(curSlot);
			
			-- check if its gold or currency ####NOPE####
			if GetLootSlotType(curSlot) == 1 then					
				itemID = GetItemID(lootLink) or nil;
				dBug("itemID", itemID);
				itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(lootLink);
			else
				itemName = lootName or "xNAx";
				itemLink = lootLink;
				itemTexture = lootIcon;
				itemType = " ";
				itemSubType = " ";
			end
			--[[
			if itemName == nil then
				itemName = "Currency";
				itemLink = "[Currency]";
				itemType = "Currency";
				itemSubType = "Currency";
			end
			]]
			
			
			-- Exclude List
			if (string.find(HotLoot:GetExcludeList(), itemName) ~= nil) then   -- WANT STRING GOT NIL "FIND" (i think its fixed)
				-- Don't Loot
				Announce(itemLink .. " has been excluded.");
			else
			--[[-------------------------------------------------------
			-------------------LOOT SWITCH-----------------------------
			---------------------------------------------------------]]
			
			if
				-- Gold
				(GetLootSlotType(curSlot) == 2) and (HotLoot:GetLootGold() == true) then 
					--itemLink = lootLink;
					LootSlot(curSlot);
					isLooted = true;
					isGold = true;
					itemName = GetCoinTextureString(ToCopper(itemName));
			elseif
				-- Currency
				(GetLootSlotType(curSlot) == 3) and (HotLoot:GetLootCurrency() == true) then 
					LootSlot(curSlot);
					isLooted = true;
			end
			if (HasRoom(1) or CanStack(itemName, itemStackCount, lootQuantity))--[[ and locked == 0 ]]then
			if
				-- Quest
				HotLoot:GetLootQuest() and ((itemType == "Quest") or ScanLootTip("Quest Item", curSlot)) and CheckThreshold("Quest", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Junk
				(itemSubType == "Junk") and (itemRarity == 0) and HotLoot:GetLootJunk() and CheckThreshold("Junk", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			--[[elseif
				-- non poor Junk
				(itemSubType == "Junk") and (itemRarity ~= 0) and (HotLoot:GetLootNPJunk() == true) and (CheckThreshold("Junk", itemSellPrice)) then 
					LootSlot(curSlot);
					isLooted = true;]]
			elseif
				-- Cloth
				(itemSubType == "Cloth") and (itemType == "Trade Goods") and HotLoot:GetLootCloth() and CheckThreshold("Cloth", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Mining
				(itemSubType == "Metal & Stone") and HotLoot:GetLootMining() and CheckThreshold("Metal & Stone", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Gems
				(itemType == "Gem") and HotLoot:GetLootGems() and CheckThreshold("Gem", itemSellPrice) then 
					LootSlot(curSlot) ;
					isLooted = true;
			elseif
				-- Herbs
				(itemSubType == "Herb") and HotLoot:GetLootHerbs() and CheckThreshold("Herb", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Leather
				(itemSubType == "Leather") and (itemType == "Trade Goods") and HotLoot:GetLootSkinning() and CheckThreshold("Leather", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Fishing (-junk)
				IsFishingLoot() and HotLoot:GetLootFishing() and (itemSubType ~= "Junk") then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- GetLootCooking
				HotLoot:GetLootCooking() and ((itemSubType == "Meat") or ScanLootTip("Cooking Ingredient", curSlot)) and CheckThreshold("Cooking Ingredient", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Pots
				(itemSubType == "Potion") and HotLoot:GetLootPots() and CheckThreshold("Potion", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Flasks
				(itemSubType == "Flask") and HotLoot:GetLootFlasks() and CheckThreshold("Flask", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Elixirs
				(itemSubType == "Elixir") and HotLoot:GetLootElixirs() and CheckThreshold("Elixir", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Motes
				(itemSubType == "Elemental") and HotLoot:GetLootElemental() and CheckThreshold("Elemental", itemSellPrice) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- MoH
				(itemID == 89112) and (HotLoot:GetLootMoH() == true) then 
					LootSlot(curSlot);
					isLooted = true;	
			elseif
				--lootBotA
				(itemID == 103642) and (HotLoot:GetLootBotA() == true) then 
					LootSlot(curSlot);
					isLooted = true;	
			elseif
				--lootDoEM
				(itemID == 103643) and (HotLoot:GetLootDoEM() == true) then 
					LootSlot(curSlot);
					isLooted = true;	
			elseif
				--lootSC
				(itemID == 103641) and (HotLoot:GetLootSC() == true) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				--lootRepMeat
				(itemID == 104265) and (HotLoot:GetLootRepMeat() == true) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				--lootRepMeat
				(itemID == 104266) and (HotLoot:GetLootRepMeat() == true) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				--lootRepMeat
				(itemID == 104264) and (HotLoot:GetLootRepMeat() == true) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				--lootRepMeat
				(itemID == 104257) and (HotLoot:GetLootRepMeat() == true) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				--lootRepMeat
				(itemID == 104267) and (HotLoot:GetLootRepMeat() == true) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Include List
				(string.find(HotLoot:GetIncludeList(), itemName) ~= nil) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Poor
				(IsInGroup() == false) and (HotLoot:GetLootPoor() == true) and (itemRarity == 0) and (CheckThreshold("z1Poor", itemSellPrice)) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Common
				(IsInGroup() == false) and (HotLoot:GetLootCommon() == true) and (itemRarity == 1) and (CheckThreshold("z2Common", itemSellPrice)) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Uncommon
				(IsInGroup() == false) and (HotLoot:GetLootUncommon() == true) and (itemRarity == 2) and (CheckThreshold("z3Uncommon", itemSellPrice)) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Rare
				(IsInGroup() == false) and (HotLoot:GetLootRare() == true) and (itemRarity == 3) and (CheckThreshold("z4Rare", itemSellPrice)) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Epic
				(IsInGroup() == false) and (HotLoot:GetLootEpic() == true) and (itemRarity == 4) and (CheckThreshold("z5Epic", itemSellPrice)) then 
					LootSlot(curSlot);
					isLooted = true;
			elseif
				-- Legendary
				(IsInGroup() == false) and (HotLoot:GetLootLegendary() == true) and (itemRarity == 5) and (CheckThreshold("z6Legendary", itemSellPrice)) then 
					LootSlot(curSlot);
					isLooted = true;
			end
			else
				bFull = 1;
			end
			end
			
			if bFull == 1 then
				Announce("Your bags are full. Please make room for HotLoot to keep looting.");
				bFull = 0;
			end
			-- debug mode
			if (HotLoot:GetLootDebug() == true) then
				print("Slot " .. curSlot .. ": " .. itemName.."| Looted: " .. tostring(isLooted));
				print("Item type: " .. itemType.."| Item sub type: " .. itemSubType);
				print("---------------");
			end
			
			if (isLooted == true) and (HotLoot:GetLootEnableMonitor() == true) then
				local itoadd = HotLoot:addLootIcon(itemTexture, itemName, itemLink, lootQuantity);
				--icons[itemName] = itoadd;
				table.insert(icons, 1, itoadd);
				tStart = GetTime();
				itoadd = nil;
				
				HotLoot:UpdateMonitor();
			end
			
			if (isLooted == false) and (HotLoot:GetLootSkinMode() or sKeyDown) and (lootQuantity > 0) then
				lItems = lItems .. " " .. lootName;
				--lItems[curSlot] = itemLink;
				LootSlot(curSlot);
				dBug(lootName, "added to lItems");
				trigger = 1;
				dBug("trigger", trigger);
			end
			-- next slot
			curSlot = curSlot + 1;
		end
		
		-- close window
		dBug("mFocus", mFocus);
		if mFocus == nil then
			mFocus = "nil";
		end
		if (HotLoot:GetLootClose() == true) and (keyDown == nil) and (string.find(mFocus, "Container") == nil) then
			closeEL = 1;
			CloseLoot();
			
		end
		
		
		--DeleteLeftovers();
		--mainFrame:Show();
	elseif (arg1 == 1) then
		Announce("You have WoW's built-in autoloot option turned on or shift is pressed. Please turn it off for HotLoot to work effectively.");
	end
end
function events:LOOT_CLOSED(...)
	dBug("loot", "closed");
	--DeleteLeftovers();
end
function events:BAG_UPDATE(...)
	if trigger == 1 then
		dBug("222222","%%%%%%%%");
		DeleteLeftovers();
		
	end
end
eFrame:SetScript("OnEvent", function(self, event, ...)
	events[event](self, ...); -- call one of the functions above
end);
for k, v in pairs(events) do
	eFrame:RegisterEvent(k); -- Register all events for which handlers have been defined
end

--function GetLeftovers
function DeleteLeftovers()
	if (HotLoot:GetLootSkinMode() == true) or (trigger == 1) then
		trigger = 0;
		dBug(" ", "starting to delete");
		dBug("lItems", lItems);
		for b = 0, 4 do 
			for s = 1, GetContainerNumSlots(b) do 
				local dLink = GetContainerItemLink(b, s);
				--dBug("dLink", dLink);
				if dLink then
					local dName = select(1, GetItemInfo(dLink));
					--dBug(lItems, dName);
					--dBug("string.find", string.find(lItems, dName));
				--for i = 1, #lItems do
					if string.find(lItems, dName) ~= nil then 
						PickupContainerItem(b, s);
						if CursorHasItem() then
							DeleteCursorItem();
							Announce(dLink .. " has been deleted.");
						end
					end
				end
			end
		end
		lItems = " ";
	end
end

--		SAVE FOR DEBUG





-- set/get functions

-- lootEnabled
function HotLoot:SetLootEnabled(info, value)
	self.db.char.lootEnabled = value;
	dBug("lootEnabled", value);
end
function HotLoot:GetLootEnabled(info)
	return self.db.char.lootEnabled;
end

-- lootEnableMonitor
function HotLoot:SetLootEnableMonitor(info, value)
	self.db.char.lootEnableMonitor = value;
	dBug("lootEnableMonitor", value);
end
function HotLoot:GetLootEnableMonitor(info)
	return self.db.char.lootEnableMonitor;
end

-- lootShowAnchor
function HotLoot:SetLootShowAnchor(info, value)
	self.db.char.lootShowAnchor = value;
	dBug("lootShowAnchor", value);
	HotLoot:ToggleAnchor(value);
end
function HotLoot:GetLootShowAnchor(info)
	return self.db.char.lootShowAnchor;
end

-- lootShowNames
function HotLoot:SetLootShowNames(info, value)
	self.db.char.lootShowNames = value;
	dBug("lootShowNames", value);
end
function HotLoot:GetLootShowNames(info)
	return self.db.char.lootShowNames;
end

-- lootShowQuantities
function HotLoot:SetLootShowQuantities(info, value)
	self.db.char.lootShowQuantities = value;
	dBug("lootShowQuantities", value);
end
function HotLoot:GetLootShowQuantities(info)
	return self.db.char.lootShowQuantities;
end

-- lootIconSize
function HotLoot:SetLootIconSize(info, value)
	self.db.char.lootIconSize = value;
	dBug("lootIconSize", value);
end
function HotLoot:GetLootIconSize(info)
	return self.db.char.lootIconSize;
end

-- SetLootTrans
function HotLoot:SetLootTrans(info, value)
	self.db.char.lootTrans = value;
	dBug("lootTrans", value);
end
function HotLoot:GetLootTrans(info)
	return self.db.char.lootTrans;
end

-- lootGrowthDirection
function HotLoot:SetLootGrowthDirection(info, value)
	self.db.char.lootGrowthDirection = value;
	dBug("lootGrowthDirection", value);
end
function HotLoot:GetLootGrowthDirection(info)
	return self.db.char.lootGrowthDirection;
end

-- HotLoot:GetTextSide()
function HotLoot:SetTextSide(info, value)
	self.db.char.textSide = value;
	dBug("textSide", value);
end
function HotLoot:GetTextSide(info)
	return self.db.char.textSide;
end

-- SetInlineQuant
function HotLoot:SetInlineQuant(info, value)
	self.db.char.inlineQuant = value;
	dBug("inlineQuant", value);
end
function HotLoot:GetInlineQuant(info)
	return self.db.char.inlineQuant;
end

-- HotLoot:GetThemeSelect()
function HotLoot:SetThemeSelect(info, value)
	self.db.char.themeSelect = value;
	dBug("themeSelect", value);
	LoadTheme(value);
end
function HotLoot:GetThemeSelect(info)
	return self.db.char.themeSelect;
end
-- LoadTheme(HotLoot:GetThemeSelect());
-- SetThemeColor
function HotLoot:SetThemeColor(info, r, g, b, a)
	self.db.char.themeColorR = r;
	self.db.char.themeColorG = g;
	self.db.char.themeColorB = b;
	self.db.char.themeColorA = a;
	dBug("themeColor", r..", "..g..", "..b..", "..a);
end
function HotLoot:GetThemeColor(info)
	return self.db.char.themeColorR, self.db.char.themeColorG, self.db.char.themeColorB, self.db.char.themeColorA;
end

function HotLoot:ToggleThemeColorHide()
	local tc = HotLoot:GetThemeSelect();
	if tc == 2 then
		--HotLoot:SetLootGridMode(false);
		return false;
	else
		return true;
	end
end
--[[
function HotLoot:ToggleNamesDisable(trig)
	if trig then
		return true;
	else
		return false;
	end
end

function HotLoot:ToggleNamesDisable(trig)
	if trig then
		return true;
	else
		return false;
	end
end
]]
-- lootGridMode
function HotLoot:SetLootGridMode(info, value)
	self.db.char.lootGridMode = value;
	dBug("lootGridMode", value);
end
function HotLoot:GetLootGridMode(info)
	return self.db.char.lootGridMode;
end

function HotLoot:ToggleGridDisable()
	local namesChecked = HotLoot:GetLootShowNames();
	if namesChecked == true then
		--self.options.args.goupLootMonitor.lootGridMode:SetDisabled(true);
		HotLoot:SetLootGridMode(false);
		return true;
	else
		--self.options.args.goupLootMonitor.lootGridMode:SetDisabled(false);
		return false;
	end
end


-- lootGridNumColumns
function HotLoot:SetLootGridNumColumns(info, value)
	self.db.char.lootGridNumColumns = value;
	dBug("lootGridNumColumns", value);
end
function HotLoot:GetLootGridNumColumns(info)
	return self.db.char.lootGridNumColumns;
end

-- TestMonitor
function HotLoot:TestMonitor()
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(6948);
	local itoadd = HotLoot:addLootIcon(itemTexture, itemName, itemLink, 5);
	table.insert(icons, 1, itoadd);
	tStart = GetTime();
	itoadd = nil;
	itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = nil;			
	HotLoot:UpdateMonitor();
end

-- ResetMonitor
function HotLoot:ResetMonitor()
	HotLoot.mainFrame:ClearAllPoints();
	HotLoot.mainFrame:SetPoint("CENTER", 0, 0);
	--HotLoot:UpdateMonitor();
	Announce("Anchor position reset.");
end

-- lootGold
function HotLoot:SetLootGold(info, value)
	self.db.char.lootGold = value;
	dBug("lootGold", value);
end
function HotLoot:GetLootGold(info)
	return self.db.char.lootGold;
end

-- lootQuest
function HotLoot:SetLootQuest(info, value)
	self.db.char.lootQuest = value;
	dBug("lootQuest", value);
end
function HotLoot:GetLootQuest(info)
	return self.db.char.lootQuest;
end

-- lootJunk
function HotLoot:SetLootJunk(info, value)
	self.db.char.lootJunk = value;
	dBug("lootJunk", value);
end
function HotLoot:GetLootJunk(info)
	return self.db.char.lootJunk;
end

-- lootJunkDel
function HotLoot:SetLootJunkDel(info, value)
	self.db.char.lootJunkDel = value;
	dBug("lootJunkDel", value);
end
function HotLoot:GetLootJunkDel(info)
	return self.db.char.lootJunkDel;
end

-- SetUnitEnable	SetTypeSelect	SetUnitKeyword	SetUnitLoot	SetUnitClose

function HotLoot:SetUnitEnable(info, value)
	self.db.char.unitEnable = value;
	dBug("GetUnitEnable", value);
end
function HotLoot:GetUnitEnable(info)
	return self.db.char.unitEnable;
end

function HotLoot:SetTypeSelect(info, key, value)
	self.db.char[key] = value;
	dBug(key, value);
end
function HotLoot:GetTypeSelect(info, key)
	return self.db.char[key];
end

function HotLoot:SetUnitKeyword(info, value)
	self.db.char.unitKeyword = value;
	dBug("UnitKeyword", value);
end
function HotLoot:GetUnitKeyword(info)
	return self.db.char.unitKeyword;
end

function HotLoot:ToggleKeywordHide()
	local uk = HotLoot:GetTypeSelect(nil,"unitKeyword");
	if uk == true then
		--HotLoot:SetLootGridMode(false);
		return false;
	else
		return true;
	end
end

function HotLoot:SetUnitLoot(info, value)
	self.db.char.unitLoot = value;
	dBug("UnitLoot", value);
end
function HotLoot:GetUnitLoot(info)
	return self.db.char.unitLoot;
end

function HotLoot:SetUnitClose(info, value)
	self.db.char.unitClose = value;
	dBug("UnitClose", value);
end
function HotLoot:GetUnitClose(info)
	return self.db.char.unitClose;
end

-- lootDebug
function HotLoot:SetLootDebug(info, value)
	self.db.char.lootDebug = value;
	dBug("lootDebug", value);
end
function HotLoot:GetLootDebug(info)
	return self.db.char.lootDebug;
end

--lootAnnounce
function HotLoot:SetLootAnnounce(info, value)
	self.db.char.lootAnnounce = value;
	dBug("lootAnnounce", value);
end
function HotLoot:GetLootAnnounce(info)
	return self.db.char.lootAnnounce;
end

-- lootClose
function HotLoot:SetLootClose(info, value)
	self.db.char.lootClose = value;
	dBug("lootClose", value);
end
function HotLoot:GetLootClose(info)
	return self.db.char.lootClose;
end

-- lootCloseKey
function HotLoot:SetLootCloseKey(info, value)
	self.db.char.lootCloseKey = value;
	dBug("lootCloseKey", value);
end
function HotLoot:GetLootCloseKey(info)
	return self.db.char.lootCloseKey;
end

-- lootSkinKey
function HotLoot:SetLootSkinKey(info, value)
	self.db.char.lootSkinKey = value;
	dBug("lootSkinKey", value);
end
function HotLoot:GetLootSkinKey(info)
	return self.db.char.lootSkinKey;
end

-- lootSkinMode
function HotLoot:SetLootSkinMode(info, value)
	self.db.char.lootSkinMode = value;
	dBug("lootSkinMode", value);
end
function HotLoot:GetLootSkinMode(info)
	return self.db.char.lootSkinMode;
end

--lootCloth
function HotLoot:SetLootCloth(info, value)
	self.db.char.lootCloth = value;
	dBug("lootCloth", value);
end
function HotLoot:GetLootCloth(info)
	return self.db.char.lootCloth;
end

--lootMining
function HotLoot:SetLootMining(info, value)
	self.db.char.lootMining = value;
	dBug("lootMining", value);
end
function HotLoot:GetLootMining(info)
	return self.db.char.lootMining;
end

--lootOre
--[[function HotLoot:SetLootOre(info, value)
	self.db.char.lootOre = value;
	dBug("lootOre", value);
end
function HotLoot:GetLootOre(info)
	return self.db.char.lootOre;
end

--lootStone
function HotLoot:SetLootStone(info, value)
	self.db.char.lootStone = value;
	dBug("lootStone", value);
end
function HotLoot:GetLootStone(info)
	return self.db.char.lootStone;
end
]]
--lootGems
function HotLoot:SetLootGems(info, value)
	self.db.char.lootGems = value;
	dBug("lootGems", value);
end
function HotLoot:GetLootGems(info)
	return self.db.char.lootGems;
end

--lootHerbs
function HotLoot:SetLootHerbs(info, value)
	self.db.char.lootHerbs = value;
	dBug("lootHerbs", value);
end
function HotLoot:GetLootHerbs(info)
	return self.db.char.lootHerbs;
end

--lootSkinning
function HotLoot:SetLootSkinning(info, value)
	self.db.char.lootSkinning = value;
	dBug("lootSkinning", value);
end
function HotLoot:GetLootSkinning(info)
	return self.db.char.lootSkinning;
end

-- lootFishing
function HotLoot:SetLootFishing(info, value)
	self.db.char.lootFishing = value;
	dBug("lootFishing", value);
end
function HotLoot:GetLootFishing(info)
	return self.db.char.lootFishing;
end

-- lootCooking
function HotLoot:SetLootCooking(info, value)
	self.db.char.lootCooking = value;
	dBug("lootCooking", value);
end
function HotLoot:GetLootCooking(info)
	return self.db.char.lootCooking;
end

-- lootPots
function HotLoot:SetLootPots(info, value)
	self.db.char.lootPots = value;
	dBug("lootPots", value);
end
function HotLoot:GetLootPots(info)
	return self.db.char.lootPots;
end

-- lootFlasks
function HotLoot:SetLootFlasks(info, value)
	self.db.char.lootFlasks = value;
	dBug("lootFlasks", value);
end
function HotLoot:GetLootFlasks(info)
	return self.db.char.lootFlasks;
end

-- lootElixirs
function HotLoot:SetLootElixirs(info, value)
	self.db.char.lootElixirs = value;
	dBug("lootElixirs", value);
end
function HotLoot:GetLootElixirs(info)
	return self.db.char.lootElixirs;
end

-- lootMoH
function HotLoot:SetLootMoH(info, value)
	self.db.char.lootMoH = value;
	dBug("lootMoH", value);
end
function HotLoot:GetLootMoH(info)
	return self.db.char.lootMoH;
end

-- excludeList
function HotLoot:SetExcludeList(info, value)
	self.db.char.excludeList = value;
	dBug("excludeList", value);
end
function HotLoot:GetExcludeList(info)
	return self.db.char.excludeList;
end

-- includeList
function HotLoot:SetIncludeList(info, value)
	self.db.char.includeList = value;
	dBug("includeList", value);
end
function HotLoot:GetIncludeList(info)
	return self.db.char.includeList;
end

-- SetLootElemental
function HotLoot:SetLootElemental(info, value)
	self.db.char.lootElemental = value;
	dBug("lootElemental", value);
end
function HotLoot:GetLootElemental(info)
	return self.db.char.lootElemental;
end

--SetLootBotA
function HotLoot:SetLootBotA(info, value)
	self.db.char.lootBotA = value;
	dBug("lootBotA", value);
end
function HotLoot:GetLootBotA(info)
	return self.db.char.lootBotA;
end

--SetLootDoEM
function HotLoot:SetLootDoEM(info, value)
	self.db.char.lootDoEM = value;
	dBug("lootDoEM", value);
end
function HotLoot:GetLootDoEM(info)
	return self.db.char.lootDoEM;
end

--SetLootSC
function HotLoot:SetLootSC(info, value)
	self.db.char.lootSC = value;
	dBug("lootSC", value);
end
function HotLoot:GetLootSC(info)
	return self.db.char.lootSC;
end

--SetLootRepMeat
function HotLoot:SetLootRepMeat(info, value)
	self.db.char.lootRepMeat = value;
	dBug("lootRepMeat", value);
end
function HotLoot:GetLootRepMeat(info)
	return self.db.char.lootRepMeat;
end

--lootPoor
function HotLoot:SetLootPoor(info, value)
	self.db.char.lootPoor = value;
	dBug("lootPoor", value);
end
function HotLoot:GetLootPoor(info)
	return self.db.char.lootPoor;
end

--lootCommon
function HotLoot:SetLootCommon(info, value)
	self.db.char.lootCommon = value;
	dBug("lootCommon", value);
end
function HotLoot:GetLootCommon(info)
	return self.db.char.lootCommon;
end

--lootUncommon
function HotLoot:SetLootUncommon(info, value)
	self.db.char.lootUncommon = value;
	dBug("lootUncommon", value);
end
function HotLoot:GetLootUncommon(info)
	return self.db.char.lootUncommon;
end

--lootRare
function HotLoot:SetLootRare(info, value)
	self.db.char.lootRare = value;
	dBug("lootRare", value);
end
function HotLoot:GetLootRare(info)
	return self.db.char.lootRare;
end

--lootEpic
function HotLoot:SetLootEpic(info, value)
	self.db.char.lootEpic = value;
	dBug("lootEpic", value);
end
function HotLoot:GetLootEpic(info)
	return self.db.char.lootEpic;
end

--lootLegendary
function HotLoot:SetLootLegendary(info, value)
	self.db.char.lootLegendary = value;
	dBug("lootLegendary", value);
end
function HotLoot:GetLootLegendary(info)
	return self.db.char.lootLegendary;
end

--lootCurrency
function HotLoot:SetLootCurrency(info, value)
	self.db.char.lootCurrency = value;
	dBug("lootCurrency", value);
end
function HotLoot:GetLootCurrency(info)
	return self.db.char.lootCurrency;
end
function ToCopper(input)
	local gold = tonumber(string.match(input,"(%d+)%s?[gG]")) or 0;
	local silver = tonumber(string.match(input,"(%d+)%s?[sS]")) or 0;
	local copper = tonumber(string.match(input,"(%d+)%s?[cC]")) or 0;
	local total = (gold*10000)+(silver*100)+(copper);
	return total;
end

--type1 
function HotLoot:SetType1(info, value)
	self.db.char.type1 = value;
	dBug("type1", value);
end
function HotLoot:GetType1(info)
	return self.db.char.type1;
end

--value1
function HotLoot:SetValue1(info, value)
	self.db.char.value1 = value;
	dBug("value1 to copper", tonumber(ToCopper(value)));
end

function HotLoot:GetValue1(info)
	return self.db.char.value1;
end

--type2
function HotLoot:SetType2(info, value)
	self.db.char.type2 = value;
	dBug("type2", value);
end
function HotLoot:GetType2(info)
	return self.db.char.type2;
end

--value2
function HotLoot:SetValue2(info, value)
	self.db.char.value2 = value;
	dBug("value2", value);
end
function HotLoot:GetValue2(info)
	return self.db.char.value2;
end

--type3
function HotLoot:SetType3(info, value)
	self.db.char.type3 = value;
	dBug("type3", value);
end
function HotLoot:GetType3(info)
	return self.db.char.type3;
end

--value3
function HotLoot:SetValue3(info, value)
	self.db.char.value3 = value;
	dBug("value3", value);
end
function HotLoot:GetValue3(info)
	return self.db.char.value3;
end


function FormatGold(info, v)
	local g, s, c;
	g = string.match(v, '(%d+)g(%d+)s(%d+)c');
	return v ~= "" 
end


-- ######## ICON WIDGET ##########

function HotLoot:ToggleAnchor(val)
	if val then
		HotLoot:ShowAnchor();
	else
		HotLoot:HideAnchor();
	end
end

function HotLoot:ShowAnchor()
	HotLoot.mainFrame:SetAlpha(1);
end

function HotLoot:HideAnchor()
	HotLoot.mainFrame:SetAlpha(0);
end


function HotLoot:UpdateMonitor()
	local i = 1;
	local yOffset;
	local xOffset;
	local row, column = 0, 0;
	if (HotLoot:GetLootGridMode() == true) and (HotLoot:GetLootShowNames() == false) then
		while i <= #icons do
			
			xOffset = column * HotLoot:GetLootIconSize(); --0, 32, 64, 96
			yOffset = ((row + 1) * (HotLoot:GetLootIconSize() * HotLoot:GetLootGrowthDirection())); --0, 0, 0, 0, 
			icons[i]:SetPoint("CENTER", HotLoot.mainFrame, "CENTER", xOffset, yOffset);
			i = i + 1;
			if column < (HotLoot:GetLootGridNumColumns() - 1) then
				column = column + 1;
			else 
				row = row + 1;
				column = 0;
			end
		end
	else
		while i <= #icons do
			yOffset = (i * ((HotLoot:GetLootIconSize() + 1) * HotLoot:GetLootGrowthDirection()));
			icons[i]:SetPoint("CENTER", HotLoot.mainFrame, "CENTER", 0, yOffset);
			i = i + 1;
		end
	end	
end

function ClearTooltips()
	GameTooltip:Hide();
	--HotLoot:UpdateMonitor();
end

function ShowTooltip(self)
	if self.item then
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR");
		GameTooltip:SetHyperlink(self.item);
		GameTooltip:Show();
	end
end

function OnEnter(self)
	mouse_focus = self;
	--GameTooltip:SetOwner(self, "ANCHOR_CURSOR");
	--GameTooltip:SetHyperlink(self.item);
	self:ShowTooltip();
end

function OnLeave(self)
	mouse_focus = nil;
	--[[
	if self._highlights then
		self.icon_frame:HideHighlight();
	end
	]]
	--GameTooltip:Hide();
	--GameTooltip:ClearLines();
	ClearTooltips();
	ResetCursor();
end

function HotLoot:addLootIcon(iPath, iName, iLink, iCount)
	--local xslot = #icons;
	--local yOffset = xslot * -32;
	local icon = self.createLootIcon(iPath, iName, iLink, iCount)
	--icon:SetParent
	icon:Show();
	
	return icon;
end
--HotLoot.itemNNN = nil;
function HotLoot.createLootIcon(iPath, iName, iLink, iCount)
	local frame = CreateFrame("Frame", iName);
	local size = HotLoot:GetLootIconSize();
	frame:SetFrameStrata("BACKGROUND");
	frame:SetWidth(size);
	frame:SetHeight(size);
	--frame:EnableMouse(true);
	
	--frame:SetPoint("CENTER", HotLoot.mainFrame, "CENTER", 0, yOffset);
	frame:SetAlpha(HotLoot:GetLootTrans());
	if iCount > 0 then
		frame:SetScript("OnEnter", OnEnter);
		frame:SetScript("OnLeave", OnLeave);
	end
	--frame:SetScript("OnUpdate", FadeItem);
	--[[
	frame:RegisterForDrag("LeftButton");
	frame:SetMovable(true);
	frame:EnableMouse(true);
	frame:SetScript("OnDragStart", frame.StartMoving);
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing);
	]]
	
	
	local icon = frame:CreateTexture(iName.."Icon","OVERLAY");
	icon:SetSize(size,size);
	icon:SetPoint("CENTER")
	icon:SetTexture(iPath);
	icon:SetTexCoord(0.07,0.93,0.07,0.93);
	--icon:SetAllPoints(frame);
	local count = frame:CreateFontString(nil, "OVERLAY");
	count:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -2, 2);
	count:SetFont(STANDARD_TEXT_FONT, 11, "OUTLINE");
	--count:SetText("x"..iCount);
	local name = frame:CreateFontString(nil, "OVERLAY");
	
	if HotLoot:GetTextSide() == 0 then
		name:SetPoint("LEFT", frame, "RIGHT", 2, 0);
		name:SetJustifyH("LEFT");
	else
		name:SetPoint("RIGHT", frame, "LEFT", -1, 0);
		name:SetJustifyH("RIGHT");
	end
	name:SetFont(STANDARD_TEXT_FONT, 9, "OUTLINE");
	name:SetWidth(129);
	name:SetHeight(16);
	
	--name:SetText(iLink);
	--GameTooltip:SetHyperlink(iLink)
	--frame:Show();
	frame.texture = icon;
	frame.item = iLink;
	frame.ShowTooltip = ShowTooltip;
	if HotLoot:GetLootShowNames() == true then
		if iCount == 0 then
			name:SetText(iName);
		else
			name:SetText(iLink);
		end
	end
	
	local iconBG = frame:CreateTexture(nil, "BORDER");
	if srcC then
		if HotLoot:GetTextSide() == 0 then
			iconBG:SetPoint("LEFT",frame,"LEFT",xOffsetC,0);
		else
			iconBG:SetPoint("LEFT",frame,"LEFT",xOffsetC-134,0);
		end
		iconBG:SetTexture("Interface\\AddOns\\HotLoot\\Themes\\"..srcC);
	end
	--SetTheme();	
	if HotLoot:GetLootShowQuantities() == true then
		if iCount > 1 then
			count:SetText("x"..iCount);
		end
		if HotLoot:GetInlineQuant() then
			if HotLoot:GetTextSide() == 0 then
				count:SetPoint("RIGHT", frame, "RIGHT", 134, 0);
				name:SetWidth(134-count:GetStringWidth());
				--name:SetWidth(120);
			else
				count:SetPoint("LEFT", frame, "LEFT", -266, 0);
				name:SetWidth(134-count:GetStringWidth());
			end
		end		
	end
	--[[
	local cR, cG, cB, cA = HotLoot:GetThemeColor();
	if HotLoot:GetThemeSelect() == 2 then
		local iconBorder = frame:CreateTexture(nil, "BORDER");
		iconBorder:SetSize(size+2,size+2);
		iconBorder:SetPoint("CENTER");
		--iconBorder:SetTexture(0,0.7,1,1);
		iconBorder:SetTexture(cR,cG,cB,cA);
		
		local nameBorder = frame:CreateTexture(nil, "BORDER");
		local nameBG = frame:CreateTexture(nil, "ARTWORK");
		
		nameBorder:SetPoint("LEFT",frame,"RIGHT",-1,0);
		nameBorder:SetTexture(cR,cG,cB,cA);
		
		nameBG:SetPoint("LEFT",nameBorder,"LEFT",0,0);
		nameBG:SetTexture(0,0,0,1);
		local nWidth, nHeight = name:GetStringWidth(), name:GetStringHeight();
		nameBorder:SetSize(nWidth+1+8,nHeight+2+4);
		nameBG:SetSize(nWidth+8,nHeight+4);
	end
	]]
	return frame;
end

local isFirst;
isFirst = 0;
function FadeItems()

	
--[[	local tTotal = 0;
	local tEnd = delay;
	local function FadeItem(self,elapsed)
		tTotal = tTotal + elapsed;
		if tTotal >= tEnd then
			UIFrameFadeOut(itemName, fadeSeconds, 1, 0);
			icons.itemName.fadeInfo.finishedFunc(table.remove(icons, itemName));
		end
	end
 ]]
	--local f = CreateFrame("frame");
	--f:SetScript("OnUpdate", FadeItems);
	if closeEL == 1 and _G["ElvLootFrame"] then
		_G["ElvLootFrame"]:Hide();
		closeEL = 0;
	end
	local iframe, alpha, fDelay;
	if (isFirst == 0) then
		isFirst = 0;
		fDelay = 5;
	else
		fDelay = 1;
	end
	if (icons[#icons] == nil) then
		isFirst = 0;
	end
	if (icons[#icons] ~= nil) and (tStart < (GetTime() - fDelay)) then
		iframe = icons[#icons];
		alpha = iframe:GetAlpha();
		--if (alpha == nil) then
		--alpha = icons[#icons]:GetAlpha();
		if (alpha ~= 0) then 
			iframe:SetAlpha(alpha - .05);
		elseif (alpha <= 0) then 
			--icons[#icons]:SetHyperlink(nil);
			iframe:Hide();
			table.remove(icons);
			dBug("#icons", #icons);
			--ClearTooltips();
			--GameTooltip:ClearAllPoints();
			--GameTooltip:ClearLines();
			--HotLoot:UpdateMonitor();		--MAYBE?
			tStart = GetTime();
			
			isFirst = isFirst + 1;
			dBug("isFirst", isFirst);
			dBug("fDelay", fDelay);
		end
	end
end
--HotLoot.mainFrame:SetScript("OnUpdate", FadeItems);